#include"eyesquat_yoyo.hpp"
#include"screen.hpp"




namespace yoyo{


enum{
  percentage_max = 100,
  percentage_min =  20,
};


namespace{


int
percentage = 100;


int
inc_table[percentage_max+1];


int
base_table[percentage_max+1];


struct
Initializer
{
  Initializer();
};


Initializer::
Initializer()
{
    for(int  n = 1;  n <= percentage_max;  ++n)
    {
      inc_table[n] = percentage_max*((percentage_max*2)-n)/n;

      base_table[n] = (chunk_size/2)-((chunk_size/2)*n/percentage_max);
    }
}


Initializer
init;


void
draw_chunk(const uint8_t*  src, const int  inc_v, const int  bottom, const int  x, int  y)
{
    if(x >= 0)
    {
      int  bas_v = inc_v;

        while(bas_v < bottom)
        {
            if(src[bas_v/100])
            {
              SDL_RenderDrawPoint(renderer,x,y);
            }


          bas_v += inc_v;
              y +=     1;
        }
    }
}


}


int
get_percentage()
{
  return (percentage >= percentage_min)? percentage:percentage_min;
}


void
step(int  v)
{
  static bool  magnify_flag;

    if(magnify_flag)
    {
      percentage += v;

        if(percentage >= percentage_max)
        {
            percentage = percentage_max;
          magnify_flag = false;
        }
    }

  else
    {
      percentage -= v;

        if(percentage <= 0)
        {
            percentage = 0;
          magnify_flag = true;
        }
    }
}




bool
draw(const ChunkBlock&  blk, int&  x)
{
  const int  p = get_percentage();

  const int  inc_v = inc_table[p];
        int  bas_v = inc_v;

  const int  base = base_table[p];

  int  tmp_x = x                      ;
               x += blk.left+blk.width;

  const int  left = (blk.left*100);

    while(bas_v < left)
    {
      bas_v += inc_v;

        if(++tmp_x >= window_w)
        {
          return true;
        }
    }


  const int   right = ((blk.left+blk.width )*100);
  const int  bottom = ((blk.top +blk.height)*100);

    while(bas_v < right)
    {
      draw_chunk(blk.chunks[bas_v/100].data,inc_v,bottom,base+tmp_x,base);

        if(++tmp_x >= window_w)
        {
          return true;
        }


      bas_v += inc_v;
    }


  return false;
}


}




