#include"font.hpp"
#include"screen.hpp"
#include<ft2build.h>
#include FT_FREETYPE_H




namespace{


FT_Library  ftlib;
FT_Face      face;


}




void
render(ChunkBlock&  blk, char16_t  unicode)
{
    if(FT_Load_Char(face,unicode,0))
    {
      return;
    }


  FT_Render_Glyph(face->glyph,FT_RENDER_MODE_MONO);

  auto  slot = face->glyph;

  auto&  bmp = slot->bitmap;

  const int  w = bmp.width;
  const int  h =  bmp.rows;

  blk.left    = slot->bitmap_left;
  blk.width   = w;
  blk.height  = h;

  auto  p = bmp.buffer;

  Chunk*  chk = &blk.chunks[blk.left];

  int  top = ((chunk_size/2)-slot->bitmap_top);

    if(top < 0)
    {
      top = 0;
    }


  blk.top = top;

    rep(n,bmp.pitch)
    {
      int  mask = 0x80;

        while(mask)
        {
          std::memset(chk,0,sizeof(*chk));

            rep(y,h)
            {
              chk->data[top+y] = ((p[bmp.pitch*y]&mask)? 1:0);
            }


          mask >>= 1;
           chk  += 1;
        }


      ++p;
    }
}


bool
open_font(const char*  path)
{
  FT_Init_FreeType(&ftlib);

    if(FT_New_Face(ftlib,path,0,&face) != 0)
    {
      char  buf[256];

      snprintf(buf,sizeof(buf),"\"%s\" not found.",path);

      SDL_ShowSimpleMessageBox(SDL_MESSAGEBOX_ERROR,"error",buf,nullptr);

      return false;
    }


  FT_Set_Pixel_Sizes(face,font_size,font_size);

  return true;
}


void
close_font()
{
  FT_Done_Face(face);
  FT_Done_FreeType(ftlib);
}




