#include"txtlin.hpp"




namespace{


bool  pause_flag;


size_t  last_pos;


size_t  speed = 16;
size_t  head_offset;
size_t  chunk_number;
size_t  advance_amount;


size_t  front_width;


std::deque<Packet>
buffer;


}




const PacketList&
get_packet_list()
{
  return buffer;
}


int
get_head_offset()
{
  return -head_offset;
}


int
get_head_pos()
{
  return(buffer.size()? buffer.front().pos:-1);
}




void
fill_buffer()
{
  const bool  flag = buffer.empty();

    while(chunk_number < (window_w*2))
    {
      buffer.emplace_back();

      chunk_number += buffer.back().get_width();
    }


    if(flag)
    {
      front_width = buffer.front().get_width();
    }
}


void
advance()
{
    if(pause_flag || get_seek_state())
    {
      return;
    }


    rep(n,speed)
    {
      ++head_offset;

        if(buffer.size())
        {
            if(head_offset >= front_width)
            {
              chunk_number -= front_width;

              buffer.pop_front();

              head_offset = 0;

                if(buffer.size())
                {
                  front_width = buffer.front().get_width();
                }
            }
        }

    }
}


void
reset_buffer()
{
  buffer.clear();

  head_offset  = 0;
  chunk_number = 0;
}




void
change_pause()
{
  pause_flag = !pause_flag;
}


void
increase_speed()
{
    if(speed < (chunk_size/3))
    {
      ++speed;
    }
}


void
decrease_speed()
{
    if(speed > 1)
    {
      --speed;
    }
}




