#include"txtlin_packet.hpp"
#include"txtlin_text.hpp"




namespace{


enum{
  cache_number_max = 256
};


std::vector<Block*>
freed_blocks;


Block*
cached_blocks[0x10000];


std::vector<char16_t>
prev_cached_char_list;


void
clean_cache()
{
    for(auto  c: prev_cached_char_list)
    {
      auto&  cache = cached_blocks[c];

        if(cache && !cache->keep_flag)
        {
          delete cache          ;
                 cache = nullptr;
        }
    }
}


}



Packet::
Packet()
{
  text::get_element(*this);

    if((unicode == '\n') ||
       (unicode == '\r'))
    {
      const uint32_t  start_pos = pos;

        for(;;)
        {
          text::get_element(*this);

            if(pos == start_pos)
            {
              break;
            }


            if((unicode != '\n') &&
               (unicode != '\r'))
            {
              break;
            }
        }
    }


  block = cached_blocks[unicode];

    if(!block)
    {
        if(freed_blocks.size())
        {
          block = freed_blocks.back();

          freed_blocks.pop_back();
        }

      else
        {
          block = new Block;
        }


      render(*block,unicode);

      cached_flag = false;
    }

  else
    {
      cached_flag = true;
    }
}


Packet::
~Packet()
{
    if(!cached_flag)
    {
      freed_blocks.emplace_back(block);
    }
}




size_t
Packet::
get_width() const
{
  return(block->left+block->width);
}


void
Packet::
renew_cache()
{
  auto&  ls = text::get_char_list();

  const int  n = std::min((int)cache_number_max,(int)ls.size());

  std::vector<char16_t>  cached_char_list;

    rep(i,n)
    {
      auto  c = ls[i];

      auto&  cache = cached_blocks[c];

        if(cache)
        {
          cache->keep_flag = true;
        }


      cached_char_list.emplace_back(c);
    }


  clean_cache();

    rep(i,n)
    {
      auto  c = ls[i];

      auto&  cache = cached_blocks[c];

        if(!cache)
        {
          cache = new Block;

          render(*cache,c);
        }


      cache->keep_flag = false;
    }


  prev_cached_char_list = std::move(cached_char_list);
}




