#include"util.hpp"
#include"font.hpp"
#include<cstdarg>




size_t
get_utf8_bytes(unsigned char  c)
{
       if(!(c>>7)           ){return 1;}
  else if( (c>>4) == 0b1110 ){return 3;}
  else if( (c>>5) == 0b110  ){return 2;}
  else if( (c>>6) == 0b10   ){return 1;}
  else if( (c>>3) == 0b11110){return 4;}


  return 0;
}


int
fget_utf8(FILE*  f)
{
  const int  c = fgetc(f);

  int  unicode = 0;

    if(!feof(f))
    {
      const size_t  bytes = get_utf8_bytes(c);

        switch(bytes)
        {
          case(1):
            unicode = c;
            break;
          case(2):
            unicode  = ((c&0b11111)<< 6);
            unicode |= (fgetc(f)&0b111111);
            break;
          case(3):
            unicode  = ((c&0b01111)<<12);
            unicode |= ((fgetc(f)&0b111111)<<6);
            unicode |= ((fgetc(f)&0b111111)   );
            break;
        }
    }


  return unicode;
}


namespace{

int
sgetc(const char*&  s)
{
  return *s++;
}


}


int
sget_utf8(const char*&  s)
{
  const int  c = *s;

  int  unicode = 0;

    if(c)
    {
      const size_t  bytes = get_utf8_bytes(*s);

      ++s;

        switch(bytes)
        {
          case(1):
            unicode = c;
            break;
          case(2):
            unicode  = ((c&0b11111)<< 6);
            unicode |= (sgetc(s)&0b111111);
            break;
          case(3):
            unicode  = ((c&0b01111)<<12);
            unicode |= ((sgetc(s)&0b111111)<<6);
            unicode |= ((sgetc(s)&0b111111)   );
            break;
        }
    }


  return unicode;
}


void
print_unicode(char16_t  c)
{
    if(c <= 0x7F)
    {
      fputc(c,stdout);
    }

  else
    if((c >= 0x0080) &&
       (c <= 0x07FF))
    {
      fputc((0b11000000|(c>>6)      ),stdout);
      fputc((0b10000000|(c&0b111111)),stdout);
    }

  else
    if((c >= 0x0800) &&
       (c <= 0xFFFF))
    {
      fputc((0b11100000|((c>>12)         )),stdout);
      fputc((0b10000000|((c>> 6)&0b111111)),stdout);
      fputc((0b10000000|((c    )&0b111111)),stdout);
    }
}





